// 1.33
//#define SDL_MAIN_HANDLED
#ifndef VSYNC
#define VSYNC "1"
#endif
#ifndef WINDOWW
#define WINDOWW 640
#define WINDOWH 400
#endif
#ifndef FONTCOLORKEY
#define FONTCOLORKEY 0
#endif
#ifndef BasicSDL
#define BasicSDL
#ifndef Basic
#include "Basic.h"
#endif
#undef Loop
#define Loop GetSDLEvents();}while(!Quit);
#include <SDL.h>
//#include <SDL_image.h>
//#include <SDL_mixer.h>
//#include <SDL_ttf.h>
#ifndef SOUNDFREQUENCY
#define SOUNDFREQUENCY 11025
#endif
#define MAXJOYS 4	// max nr joysticks
union BASSDLColor{
	SDL_Color SDL;
	Uint32 BAS;
} Color={.SDL={255,255,255,255}}, ColorB={0}, ColorC;
Uint16 WindowEvent;
Uint8 Quit=0;
const Uint8*SDLKeyboardState=NULL;
Uint32 InKey;	// Keycode
int MouseX,MouseY;Uint32 MouseK;
char*SDLTEXT$=STRING$;
SDL_Finger*SDLFinger=NULL;
SDL_TouchID SDLTouchID;
SDL_Joystick*SDLJoystick[MAXJOYS];
SDL_Window*SDLWindow=NULL;
SDL_Renderer*SDLRenderer=NULL;
SDL_DisplayMode Display;
SDL_Rect SRC,DST;
SDL_Surface*SDLSurface=NULL;
SDL_Texture*SDLTexture=NULL;
SDL_RWops*SDLRWops=NULL;
#ifdef SDL_TTF_H_
TTF_Font*TTFFont=NULL;
#endif
#ifdef SDL_MIXER_H_
Mix_Music*MixMusic=NULL;
#endif
SDL_Texture*BASFont=NULL;
struct GPRINT{
	SDL_Texture*T;
	int x,y;
	Uint8 sw,sh;
	Uint16 w,h;} GPR={NULL,0,0,8,8,16,16};
#define SDL_BLENDMODE_REV SDL_ComposeCustomBlendMode(\
	SDL_BLENDFACTOR_ONE,\
	SDL_BLENDFACTOR_ONE,\
	SDL_BLENDOPERATION_REV_SUBTRACT,\
	SDL_BLENDFACTOR_ONE,\
	SDL_BLENDFACTOR_ONE,\
	SDL_BLENDOPERATION_REV_SUBTRACT)
#define SDLOpen(flags) SDLInit(flags);
void SDLInit(Uint32 window_flags){
	if(SDL_Init(SDL_INIT_EVERYTHING) != 0) {puts(SDL_GetError());exit(1);}
	SDL_SetHint(SDL_HINT_RENDER_VSYNC, VSYNC);
	SDL_CreateWindowAndRenderer(WINDOWW,WINDOWH, window_flags, &SDLWindow, &SDLRenderer);
	SDL_RenderClear(SDLRenderer);
	SDL_StopTextInput();
	Uint8 j;
	for (j=0;j<MAXJOYS;++j) if (j<SDL_NumJoysticks()) SDLJoystick[j]=SDL_JoystickOpen(j);
	SDLTouchID=SDL_GetTouchDevice(0);
	SDL_GetCurrentDisplayMode(0,&Display);
#ifdef SDL_MIXER_H_
	if(Mix_OpenAudio(SOUNDFREQUENCY,MIX_DEFAULT_FORMAT,2,2048 )<0) puts(Mix_GetError());
#endif
	SDLSurface=SDL_LoadBMP("BASFont.bmp");if(!SDLSurface) puts(SDL_GetError());else{
	if(FONTCOLORKEY>=0) SDL_SetColorKey(SDLSurface,1,FONTCOLORKEY);
	BASFont=SDL_CreateTextureFromSurface(SDLRenderer,SDLSurface);GPR.T=BASFont;}
#ifdef SDL_TTF_H_
	if(TTF_Init()!=0) puts(TTF_GetError());
#endif
}
#define CenterWindow SDL_SetWindowPosition(SDLWindow,SDL_WINDOWPOS_CENTERED,SDL_WINDOWPOS_CENTERED);
#define CloseWindow SDL_DestroyWindow(SDL_Window);
#define FullscreenWindow SDL_SetWindowFullscreen(SDLWindow,SDL_WINDOW_FULLSCREEN_DESKTOP);
#define GetDisplayMode SDL_GetCurrentDisplayMode(0,&Display); //Display.w .h .refresh_rate .driverdata
#define GetWindowSize(w,h) SDL_GetWindowSize(SDLWindow,&w,&h);
#define MaximizeWindow SDL_MaximizeWindow(SDLWindow);
#define MinimizeWindow SDL_MinimizeWindow(SDLWindow);
#define RestoreWindow SDL_RestoreWindow(SDLWindow);
#define WindowPos(x,y) SDL_SetWindowPosition(SDLWindow,x,y);
#define WindowSize(w,h) SDL_SetWindowSize(SDLWindow,w,h);
#define WindowVirtualSize(w,h) SDL_RenderSetLogicalSize(SDLRenderer,w,h);

#define SRC(X,Y,W,H) {SRC.x=X;SRC.y=Y;SRC.w=W;SRC.h=H;}
#define DST(X,Y,W,H) {DST.x=X;DST.y=Y;DST.w=W;DST.h=H;}
#define DegAt(W,H) (atan2(W,-(H))*57.29578)
#define Distance(x,y,x2,y2) sqrt(((x)-(x2))*((x)-(x2))+((y)-(y2))*((y)-(y2)))
#define PointInCircle(Px,Py,X,Y,R) (sqrt((Px-(X))*(Px-(X))+(Py-(Y))*(Py-(Y)))<=R)
#define PointInBox(x,y,x1,y1,x2,y2) ((x)<=(x2)&&(x)>=(x1)&&(y)<=(y2)&&(y)>=(y1))
#define PointInRect(x,y,x1,y1,w,h) ((x)<(x1)+(w)&&(x)>=(x1)&&(y)<(y1)+(h)&&(y)>=(y1))
#define CircleCollide(x,y,r,x2,y2,r2) (sqrt(((x)-(x2))*((x)-(x2))+((y)-(y2))*((y)-(y2)))<=((r)+(r2)))
#define RectCollide(A,B) SDL_HasIntersection(&A,&B)

#define ColorRGBA(r,g,b,a) SDL_SetRenderDrawColor(SDLRenderer,r,g,b,a);
#define ColorSDL(C) SDL_SetRenderDrawColor(SDLRenderer,C.r,C.g,C.b,C.a);
#define Color(k) {Color.BAS=k;SDL_SetRenderDrawColor(SDLRenderer,Color.SDL.r,Color.SDL.g,Color.SDL.b,Color.SDL.a);}
#define Colors(F,B) {Color.BAS=F;ColorB.BAS=B;}
#define SDL_Color(C,R,G,B,A) {C.r=R;C.g=G;C.b=B;C.a=A;}
Uint32 RGBA(Uint8 R,Uint8 G,Uint8 B,Uint8 A) {union BASSDLColor C={.SDL={R,G,B,A}};return C.BAS;}
#define Cls SDL_RenderClear(SDLRenderer);
#define IntScaling(enable) SDL_RenderSetIntegerScale(SDLRenderer,enable);
#define SetScale(scaleX,scaleY) SDL_RenderSetScale(SDLRenderer,scaleX,scaleY);
#define Clip(X,Y,W,H) {DST.x=X;DST.y=Y;DST.w=W;DST.h=H;SDL_RenderSetClipRect(SDLRenderer,&DST);}
#define SetDrawBlendMode(Mode) SDL_SetRenderDrawBlendMode(SDLRenderer,Mode);
#define ShowPage SDL_RenderPresent(SDLRenderer);
#define Viewport(X,Y,W,H) {DST.x=X;DST.y=Y;DST.w=W;DST.h=H;SDL_RenderSetViewport(SDLRenderer,&DST);}

#define CopyImg(T1,T2){\
	SDL_QueryTexture(T1,NULL,NULL,&DST.w,&DST.h);\
	if(T2) SDL_DestroyTexture(T2);\
	T2=SDL_CreateTexture(SDLRenderer,SDL_PIXELFORMAT_RGBA32,SDL_TEXTUREACCESS_TARGET,DST.w,DST.h);\
	SDL_SetRenderTarget(SDLRenderer,T2);\
	SDL_SetRenderDrawColor(SDLRenderer,0,0,0,0);\
	SDL_RenderClear(SDLRenderer);\
	SDL_RenderCopy(SDLRenderer,T1,NULL,NULL);\
	SDL_SetRenderTarget(SDLRenderer,NULL);}
#define CreateImg(T,w,h) T=SDL_CreateTexture(SDLRenderer,SDL_PIXELFORMAT_RGBA32,SDL_TEXTUREACCESS_TARGET,w,h);
#define CreateImgBitmap(T,P,w,h) {T=SDL_CreateTexture(SDLRenderer,SDL_PIXELFORMAT_RGBA32,SDL_TEXTUREACCESS_STATIC,w,h);SDL_UpdateTexture(T,NULL,P,w*4);}
#define DeleteImg(T) {SDL_DestroyTexture(T);T=NULL;}
#define GetBitmap(X,Y,W,H,pixels) {SRC.x=X;SRC.y=Y;SRC.w=W;SRC.h=H;SDL_RenderReadPixels(SDLRenderer,&SRC,SDL_PIXELFORMAT_RGBA32,pixels,W*4);}
#define ImgBitmap(T,P,w) SDL_UpdateTexture(T,NULL,P,w*4);
#define GetImg(X,Y,W,H,T) GetTexture(&T,X,Y,W,H);
#define InvertImg(S,T) InvertTexture(&T,S);
#define InvertImgBitmap(T,pixels,W,H) InvertPixelsTexture(&T,pixels,W,H);
#define ImgAlphaMod(texture,alpha) SDL_SetTextureAlphaMod(texture,alpha);
#define ImgBlendMode(texture,blend) SDL_SetTextureBlendMode(texture,blend);
#define ImgColorModRGB(texture,r,g,b) SDL_SetTextureColorMod(texture,r,g,b);
#define ImgColorMod(texture,k) {Color.BAS=k;SDL_SetTextureColorMod(texture,Color.SDL.r,Color.SDL.g,Color.SDL.b);}
#define ImgSize(T) {SDL_QueryTexture(T,NULL,NULL,&DST.w,&DST.h);SRC.w=DST.w;SRC.h=DST.h;}
#define InsertImg(T) SDL_RenderCopy(SDLRenderer,T,NULL,NULL);
#define PutImg(T,X,Y) {SDL_QueryTexture(T,NULL,NULL,&DST.w,&DST.h);DST.x=X;DST.y=Y;SDL_RenderCopy(SDLRenderer,T,NULL,&DST);}
#define PutImgScale(T,X,Y,SW,SH) {SDL_QueryTexture(T,NULL,NULL,&DST.w,&DST.h);DST.x=X;DST.y=Y;DST.w*=SW;DST.h*=SH;SDL_RenderCopy(SDLRenderer,T,NULL,&DST);}
#define PutImgSize(T,X,Y,W,H) {DST.x=X;DST.y=Y;DST.w=W;DST.h=H;SDL_RenderCopy(SDLRenderer,T,NULL,&DST);}
#define PutImgRect(T,S,D) SDL_RenderCopy(SDLRenderer,T,&S,&D);
#define PutImgRotoFlip(T,X,Y,R,F) {SDL_QueryTexture(T,NULL,NULL,&DST.w,&DST.h);DST.x=X;DST.y=Y;SDL_RenderCopyEx(SDLRenderer,T,NULL,&DST,R,NULL,F);}
#define PutImgREF(T,S,D,R,F) SDL_RenderCopyEx(SDLRenderer,T,&S,&D,R,NULL,F);
#define PutImgREX(T,S,D,R,C,F) SDL_RenderCopyEx(SDLRenderer,T,&S,&D,R,&C,F);
#define Target(texture) SDL_SetRenderTarget(SDLRenderer,texture);
void GetTexture(SDL_Texture**T,int X,int Y,int W,int H){
	char bufor[W*H*4];
	GetBitmap(X,Y,W,H,bufor)
	if(*T==NULL) *T=SDL_CreateTexture(SDLRenderer,SDL_PIXELFORMAT_RGBA32,SDL_TEXTUREACCESS_STATIC,W,H);
	ImgBitmap(*T,bufor,W)
}
#define ColorKey(surface,R,G,B) SDL_SetColorKey(surface,1,SDL_MapRGB(surface->format,R,G,B));
#define InvertImgSurface(S,T) InvertSurfaceTexture(&T,S);
#define LoadImg(T,N) {LoadSDLSurface(N,-1);if(SDLSurface)T=SDL_CreateTextureFromSurface(SDLRenderer,SDLSurface);}
#define LoadImgKey(T,N,K) {LoadSDLSurface(N,K);if(SDLSurface)T=SDL_CreateTextureFromSurface(SDLRenderer,SDLSurface);}
#define SaveBMP(X,Y,W,H,N) SaveSurface(X,Y,W,H,N);
void LoadSDLSurface(char*N,int K){
	if(SDLSurface) SDL_FreeSurface(SDLSurface);
#ifdef SDL_IMAGE_H_
	SDLSurface=IMG_Load(N);
#else
	SDLSurface=SDL_LoadBMP(N);
#endif
	if(!SDLSurface) puts(SDL_GetError());
	if(K>=0) {Color.BAS=K;SDL_SetColorKey(SDLSurface,1,SDL_MapRGB(SDLSurface->format,Color.SDL.r,Color.SDL.g,Color.SDL.b));}
}
void InvertPixelsTexture(SDL_Texture**T,void*pixels,int W,int H){
	void*Pixels;int Pitch;
	if(*T) SDL_DestroyTexture(*T);
	*T=SDL_CreateTexture(SDLRenderer,SDL_PIXELFORMAT_RGBA32,SDL_TEXTUREACCESS_STREAMING,W,H);
	SDL_LockTexture(*T,NULL,&Pixels,&Pitch);
	Uint32* pix=(Uint32*)Pixels;
	Uint32* spix=(Uint32*)pixels;
	int i;
	for(i=0;i<W*H;++i) pix[i]=~spix[i];
	SDL_UnlockTexture(*T);
}
void InvertSurfaceTexture(SDL_Texture**T,SDL_Surface*S){
	SDL_Surface*CS=SDL_ConvertSurfaceFormat(S,SDL_PIXELFORMAT_RGBA32,0);
	InvertPixelsTexture(T,CS->pixels,CS->w,CS->h);
	SDL_FreeSurface(CS);
}
void InvertTexture(SDL_Texture**T,SDL_Texture*S){
	int w,h;
	SDL_SetTextureBlendMode(S,SDL_BLENDMODE_REV);
	if(*T) SDL_DestroyTexture(*T);
	SDL_QueryTexture(S,NULL,NULL,&w,&h);
	*T=SDL_CreateTexture(SDLRenderer,SDL_PIXELFORMAT_RGBA32,SDL_TEXTUREACCESS_TARGET,w,h);
	SDL_SetRenderTarget(SDLRenderer,*T);
	SDL_SetRenderDrawColor(SDLRenderer,255,255,255,255);
	SDL_RenderClear(SDLRenderer);
	SDL_RenderCopy(SDLRenderer,S,NULL,NULL);
}
void SaveSurface(int X,int Y,int W,int H,char*N){
	if(SDLSurface) SDL_FreeSurface(SDLSurface);
	char bufor[W*H*4];
	GetBitmap(X,Y,W,H,bufor)
	SDLSurface=SDL_CreateRGBSurfaceFrom((void*)bufor,W,H,32,W*4,0xff0000,65280,255,0);
	SDL_SaveBMP(SDLSurface,N);
}
#define InKey(K) SDLKeyboardState[K]	// Scancode
#define WaitInKey do GetSDLEvents(); while(InKey==0 && Quit==0);
#define WaitMouseU do GetSDLEvents(); while(MouseK>0 && Quit==0);
#define WaitMouseD do GetSDLEvents(); while(MouseK==0 && Quit==0);
#define StartTextInput(T) {SDL_StartTextInput();SDLTEXT$=T;}
#define StopTextInput SDL_StopTextInput();
#define GetFinger(F) SDLFinger=SDL_GetTouchFinger(SDLTouchID,F);
#define NumFingers SDL_GetNumTouchFingers(SDLTouchID)
#define Stick(J,S) SDL_JoystickGetAxis(SDLJoystick[J],S)	//-32768-32767
#define Strig(J,S) SDL_JoystickGetButton(SDLJoystick[J],S)
#define NumJoys SDL_NumJoysticks()
#define SetMouse(x,y) SDL_WarpMouseInWindow(SDLWindow,x,y);
#define ShowM(s) SDL_ShowCursor(s);
#define WindowEvent(E) (WindowEvent&(1<<E))
#define GetEvents GetSDLEvents();
void GetSDLEvents(){
  SDL_Event e;
  Uint32 windowID = SDL_GetWindowID(SDLWindow);
  WindowEvent=0;
  InKey=0;
  while(SDL_PollEvent(&e)){
    switch(e.type){
      case SDL_WINDOWEVENT:
        if(e.window.windowID==windowID) WindowEvent|=1<<e.window.event;
      break;
      case SDL_QUIT:
        Quit=1;
      break;
      case SDL_KEYDOWN:
        InKey=e.key.keysym.sym;
        break;
      case SDL_TEXTINPUT:
        strncat(SDLTEXT$,e.text.text,STRLEN-strlen(SDLTEXT$));
      break;
  } }
  SDLKeyboardState = SDL_GetKeyboardState(NULL);
  MouseK=SDL_GetMouseState(&MouseX,&MouseY);
}
#define Draw(x1,y1,x2,y2) SDL_RenderDrawLine(SDLRenderer,x1,y1,x2,y2);
#define Line(x,y,W,H) SDL_RenderDrawLine(SDLRenderer,x,y,x+W-1,y+H-1);
#define Lines(points,nrp) SDL_RenderDrawLines(SDLRenderer,points,nrp);
#define Plot(x,y) SDL_RenderDrawPoint(SDLRenderer,x,y);
#define Points(points,count) SDL_RenderDrawPoints(SDLRenderer,points,count);
#define Rect(X,Y,W,H) {DST.x=X;DST.y=Y;DST.w=W;DST.h=H;SDL_RenderDrawRect(SDLRenderer,&DST);}
#define Box(X,Y,X2,Y2) {DST.x=X;DST.y=Y;DST.w=(X2)-(X)+1;DST.h=(Y2)-(Y)+1;SDL_RenderDrawRect(SDLRenderer,&DST);}
#define PBox(X,Y,X2,Y2) {DST.x=X;DST.y=Y;DST.w=(X2)-(X)+1;DST.h=(Y2)-(Y)+1;SDL_RenderFillRect(SDLRenderer,&DST);}
#define Rects(rects,count) SDL_RenderDrawRects(SDLRenderer,rects,count);
#define PRect(X,Y,W,H) {DST.x=X;DST.y=Y;DST.w=W;DST.h=H;SDL_RenderFillRect(SDLRenderer,&DST);}
#define PRects(rects,count) SDL_RenderFillRects(SDLRenderer,rects,count);
#define Circle(xs,ys,r) DrawCircle(xs,ys,r);
#define PCircle(xs,ys,r) DrawCircleF(xs,ys,r);
void DrawCircle(int xs,int ys,int y){
  int x=0,e=0,e1,e2;
  SDL_Point P[8];
  while(x<=y){
    P[0].x=x+xs;P[0].y=y+ys;
    P[1].x=y+xs;P[1].y=-x+ys;
    P[2].x=-x+xs;P[2].y=-y+ys;
    P[3].x=-y+xs;P[3].y=x+ys;
    P[4].x=y+xs;P[4].y=x+ys;
    P[5].x=x+xs;P[5].y=-y+ys;
    P[6].x=-y+xs;P[6].y=-x+ys;
    P[7].x=-x+xs;P[7].y=y+ys;
    SDL_RenderDrawPoints(SDLRenderer,P,8);
    e1=e+(x<<2)+1;e2=e1-(y<<2)+1;
    if(e1+e2<0)e=e1;else{y--;e=e2;}
    x++;
} }
void DrawCircleF(int xs,int ys,int y){
  int x=0,e=0,e1,e2;
  while (x<=y){
    SDL_RenderDrawLine(SDLRenderer,-y+xs,x+ys,y+xs,x+ys);
    SDL_RenderDrawLine(SDLRenderer,-y+xs,-x+ys,y+xs,-x+ys);
    e1=e+(x<<2)+1;e2=e1-(y<<2)+1;
    if(e1+e2<0) e=e1;
    else{
      SDL_RenderDrawLine(SDLRenderer,-x+xs,y+ys,x+xs,y+ys);
      SDL_RenderDrawLine(SDLRenderer,-x+xs,-y+ys,x+xs,-y+ys);
      y--;e=e2;}
	x++;
} }
#define GPrint(t) SDLGPrint(t,STRLEN,1,WINDOWW,WINDOWH,0);
#define GPrintn(t,n) SDLGPrint(t,n,1,WINDOWW,WINDOWH,0);
#define GPrintAt(X,Y,t) {GPR.x=(X);GPR.y=(Y);SDLGPrint(t,STRLEN,1,WINDOWW,WINDOWH,0);}
#define GPrintnAt(X,Y,t,n) {GPR.x=(X);GPR.y=(Y);SDLGPrint(t,n,1,WINDOWW,WINDOWH,0);}
#define GPr(D) {snprintf(STRING$, STRLEN+1, "%.12lG", (double)D);SDLGPrint(STRING$,STRLEN,1,WINDOWW,WINDOWH,0);}
#define GPrn(D,N) {snprintf(STRING$, N+1, "%.12lG", (double)D);SDLGPrint(STRING$,STRLEN,1,WINDOWW,WINDOWH,0);}
#define GPrAt(X,Y,D) {GPR.x=(X);GPR.y=(Y);GPr(D)}
#define GPrnAt(X,Y,D,N) {GPR.x=(X);GPR.y=(Y);GPrn(D,N)}
#define GPrintF(F,...) {snprintf(STRING$, STRLEN+1, F,__VA_ARGS__);SDLGPrint(STRING$,STRLEN,1,WINDOWW,WINDOWH,0);}
#define GPrintFAt(X,Y,F,...) {GPR.x=(X);GPR.y=(Y);GPrintF(F,__VA_ARGS__)}
#define GPColorRGB(r,g,b) SDL_SetTextureColorMod(GPR.T,r,g,b);
#define GPColor(c) {ColorC.BAS=c;SDL_SetTextureColorMod(GPR.T,ColorC.SDL.r,ColorC.SDL.g,ColorC.SDL.b);}
#define SetFont(W,H) {GPR.w=W;GPR.h=H;}
void SDLGPrint(const void*st,int m,int l,int X,int Y,Uint8 b){
	char *t,*c="ĄĆĘŁŃÓŚŹąćęłńóśźŻż";
	STRING*s=(STRING*)st;
	int i,a=0,p,k=0,n;
	SDL_Rect S,D;
	S.y=0;S.w=GPR.sw;S.h=GPR.sh;
	D.x=GPR.x;D.y=GPR.y;D.w=GPR.w;D.h=GPR.h;
	for(;k<l;k++){t=s[k];i=0;n=m;
	 while(n-- && t[i]){
		if(D.x>X){if(b)break;D.y+=GPR.h;D.x=GPR.x;}
		if(t[i]=='\n'){D.y+=GPR.h;D.x=GPR.x;}
		else{
			if(t[i]>=32&&t[i]<=127) a=t[i]-32;
			else{
				for(p=0;p<36;p+=2){
					if(t[i]==c[p]&&t[i+1]==c[p+1]){
						a=(p>>1)+96;i++;break;
			}	}	}
			S.x=a*GPR.sw;
			SDL_RenderCopy(SDLRenderer,GPR.T,&S,&D);
			D.x+=GPR.w;
		}i++;
	 }if(l>1){D.y+=GPR.h;D.x=GPR.x;}if(D.y>Y)break;
	}
	GPR.x=D.x;GPR.y=D.y;}
#define RWOpen(N,M) SDLRWops=SDL_RWFromFile(N,#M);
#define RWClose SDL_RWclose(SDLRWops);
#define RWBGet(b,n) SDL_RWread(SDLRWops,b,1,n);
#define RWBPut(b,n) SDL_RWwrite(SDLRWops,b,1,n);
#define RWBLoad(F,b,n) {SDLRWops=SDL_RWFromFile(F,"rb");SDL_RWread(SDLRWops,b,1,n);SDL_RWclose(SDLRWops);}
#define RWBSave(F,b,n) {SDLRWops=SDL_RWFromFile(F,"wb");SDL_RWwrite(SDLRWops,b,1,n);SDL_RWclose(SDLRWops);}
#define RWInp SDL_ReadU8(SDLRWops)
#define RWOut(c) SDL_WriteU8(SDLRWops,c);
#define RWLoc SDL_RWtell(SDLRWops)
#define RWLof SDL_RWsize(SDLRWops)
#define RWSeek(D,S) SDL_RWseek(SDLRWops,D,RW_SEEK_##S);

#ifdef SDL_TTF_H_
#define LoadFont(Font,FileN,Size) {Font=TTF_OpenFont(FileN,Size);if(!Font) puts(TTF_GetError()); else TTFFont=Font;}
#define FontStyle(style) TTF_SetFontStyle(TTFFont,style);	//1=TTF_STYLE_BOLD 2=TTF_STYLE_ITALIC 0=TTF_STYLE_NORMAL 4=TTF_STYLE_UNDERLINE
#define Text(X,Y,Txt,M) {TextToImg(TTFFont,M,Txt,&SDLTexture);PutImg(SDLTexture,X,Y);}
#define TextSize(txt,w,h) TTF_SizeText(TTFFont,txt,&w,&h));
#define TextImg(Txt,T,M) TextToImg(TTFFont,M,Txt,&T);
void TextToImg(TTF_Font*Font,Uint8 M,char*Txt,SDL_Texture**T){
	SDL_FreeSurface(SDLSurface);
	if(M==0) SDLSurface=TTF_RenderText_Solid(Font,Txt,Color.SDL);
	else if(M==1) SDLSurface=TTF_RenderText_Shaded(Font,Txt,Color.SDL,ColorB.SDL);
	else SDLSurface=TTF_RenderText_Blended(Font,Txt,Color.SDL);
	if(*T) SDL_DestroyTexture(*T);
	*T=SDL_CreateTextureFromSurface(SDLRenderer,SDLSurface);
}
#endif
#ifdef SDL_MIXER_H_
#define LoadMusic(FM) {Mix_FreeMusic(MixMusic);MixMusic=Mix_LoadMUS(FM);if(!MixMusic) puts(Mix_GetError());}
#define PlayMusic(loops) Mix_PlayMusic(MixMusic,loops);
#define PlayingMusic Mix_PlayingMusic()
#define FadeInMusic(loops,ms) Mix_FadeInMusic(MixMusic,loops,ms);
#define FadeOutMusic(ms) Mix_FadeOutMusic(ms);
#define MusicVolume(volume) Mix_VolumeMusic(volume);
#define PauseMusic Mix_PauseMusic();
#define PausedMusic Mix_PausedMusic()
#define ResumeMusic Mix_ResumeMusic();
#define SetMusicPosition(position) Mix_SetMusicPosition(position);
#define HaltMusic Mix_HaltMusic();
#define LoadSound(S,FS) {S=Mix_LoadWAV(FS);if(!S) puts(Mix_GetError());}
#define PlaySound(S,channel,loops) Mix_PlayChannel(channel,S,loops);
#define PlaySoundTimed(S,channel,loops,ticks) Mix_PlayChannelTimed(channel,S,loops,ticks);
#define PlaySoundFadeIn(S,channel,loops,ms) Mix_FadeInChannel(channel,S,loops,ms);
#define PlaySoundFadeInTimed(S,channel,loops,ms,ticks) Mix_FadeInChannelTimed(channel,S,loops,ms,ticks);
#define SoundVolume(S,volume) Mix_VolumeChunk(S,volume);	// 0-128
#define DeleteSound(S) Mix_FreeChunk(S);
#define ChannelVolume(channel,volume) Mix_Volume(channel,volume);	// -1 all
#define PauseChannel(channel) Mix_Pause(channel);
#define PausedChannel(channel) Mix_Paused(channel)
#define ResumeChannel(channel) Mix_Resume(int channel);
#define HaltChannel(channel) Mix_HaltChannel(channel);
#define ExpireChannel(channel,ticks) Mix_ExpireChannel(channel,ticks);
#define FadeOutChannel(channel,ms) Mix_FadeOutChannel(channel,ms);
#define PlayingChannel(channel) Mix_Playing(channel)
#define ChannelPanning(channel,left,right) Mix_SetPanning(channel,left,right);
#define ChannelDistance(channel,distance) Mix_SetDistance(channel,distance);
#define ChannelPosition(channel,angle,distance) Mix_SetPosition(channel,angle,distance);
#define ReverseStereo(channel,flip) Mix_SetReverseStereo(channel,flip);
#define MulSoundFreq(S,SS,mul) S=ChunkConvertFrequency(SS,mul);
Mix_Chunk*ChunkConvertFrequency(Mix_Chunk*SChunk,float mul){
  SDL_AudioCVT cvt;
  SDL_BuildAudioCVT(&cvt, MIX_DEFAULT_FORMAT, 2, SOUNDFREQUENCY*mul, MIX_DEFAULT_FORMAT, 2, SOUNDFREQUENCY);
  cvt.len = SChunk->alen;
  cvt.buf = (Uint8 *) SDL_malloc(cvt.len * cvt.len_mult);
  memmove(cvt.buf,SChunk->abuf,SChunk->alen);
  SDL_ConvertAudio(&cvt);
  Mix_Chunk*chunk;
  chunk=(Mix_Chunk*)SDL_malloc(sizeof(Mix_Chunk));
  chunk->abuf=cvt.buf;
  chunk->alen=cvt.len_cvt;
  chunk->allocated=1;
  chunk->volume=MIX_MAX_VOLUME;
  return chunk;
}
#endif
#define Pause(ms) SDL_Delay(ms);
#define SDLTime SDL_GetTicks()
#define SDLQuit QuitSDL();
void QuitSDL(){
	if(SDLSurface) SDL_FreeSurface(SDLSurface);
	if(BASFont) SDL_DestroyTexture(BASFont);
	if(SDLTexture) SDL_DestroyTexture(SDLTexture);
	if(SDLRenderer) SDL_DestroyRenderer(SDLRenderer);
	if(SDLWindow) SDL_DestroyWindow(SDLWindow);
	Uint8 j;
	for(j=0;j<MAXJOYS;++j) if(SDL_JoystickGetAttached(SDLJoystick[j])) SDL_JoystickClose(SDLJoystick[j]);
#ifdef SDL_MIXER_H_
	if(MixMusic) Mix_FreeMusic(MixMusic);
	Mix_CloseAudio();
	Mix_Quit();
#endif
#ifdef SDL_TTF_H_
	if(TTFFont) TTF_CloseFont(TTFFont);
	TTF_Quit();
#endif
	SDL_Quit();
}
#endif
