// *****************************************************************************
// *                                                                           *
// *                                NIKIFOR 2                                  *
// * (Najkrotszy Inteligentny Kreator Ilustracji, Form Obrazkowych i Rysunkow) *
// *          Autor: Michal Setlak. (C) 1989 ImaGraph Creative Software        *
// *    Ulepszenia, wersja BasicC: Robert Osypowicz, (C) 1991-2022 Belzebub    *
// *                                                                           *
// *****************************************************************************
#define SDL_MAIN_HANDLED
#define DEBUG 1
#include "BasicGEM.h"
//      Nazwy i kody trybow graficznych
char*tryb$[5]={"Wymiana","Mieszanie","Suma","Iloczyn","Inwersja"};
SDL_BlendMode tryb_b[5]={0,SDL_BLENDMODE_BLEND,SDL_BLENDMODE_ADD,SDL_BLENDMODE_MOD};
//	Rozszerzenia i dlugosci plikow
char*typ$[3]={".PI",".BMP",".BMP"};
struct GEMBOX boxy[81]={{"Ładuj"},{"Zapisz"},{"DEGAS"},{"Doodle"},{"BMP"},{"BMP"},{"...blok"},{"...blok"},
	{"Punkt"},{"Rysunek"},{"Linia"},{"Łamana"},{"Ramka"},{"Prostokąt"},{"Okrąg"},{"Koło"},{"Elipsa"},{"Dysk"},
	{"Blok"},{"Wypełnienie"},{"Powiększenie"},{0},{"Czyść"},{"Koniec"}};
int n,k,x,y,key,kr=0,krh=0,krv=0;
SDL_Texture*rob_e$=0,*kra$=0,*blok$=0,*Wypboxy;
Uint8 co=1;	//Kod operacji: rysunek z reki
Uint8 kolor=1;	//Kolor: czarny
Uint8 wyp=0;	//Desen: gladki
Uint8 lin_r=0;	//Rodzaj linii: ciagla
Uint8 lin_szer=1;	//Szerokosc linii
Uint8 tryb=0;	//tryb mieszania
Uint32 defline[7]={0xFFFFFFFF,0xFFF0FFF0,0xC0C0C0C0,0xFF18FF18,0xFF00FF00,0xF8C8F8C8,0xFFC0C0C0};	//definicje lini
#define BOX(B,X,Y,W,H) B.x=X;B.y=Y;B.w=W;B.h=H;
// *****************************************************************************

Procedure ShowE() Def
  Target(0)
  InsertImg(GEMScreen)
  if(kr>0)InsertImg(kra$)
  ShowPage
  Target(GEMScreen)
EndProc

//***** Procedury graficzne*****

Procedure plot(int x,int y) Def
  if(lin_szer<2)
    Plot(x,y)
  else
    PCircle(x,y,lin_szer/2)
EndProc

Procedure line(int x1,int y1,int x2,int y2,Uint8 lin_r) Def
  int dx,dy,kx,ky,e,i;
  Uint32 mask=0,p=defline[lin_r];	//rodzaje lini
  // Przyrosty w osiach x i y
  if(x1 <= x2) kx = 1; else kx = -1;
  if(y1 <= y2) ky = 1; else ky = -1;
  // Odległości pomiędzy punkatami startowym a końcowym wzdłuż osi
  dx = x2 - x1; if(dx < 0) dx = -dx;
  dy = y2 - y1; if(dy < 0) dy = -dy;
  // Rysujemy punkt startowy
  mask >>= 1; if(!mask) mask = 0x80000000;
  if(p & mask)plot(x1,y1);
  if(dx < dy){ Swap(dx,dy) Swap(x1,y1) Swap(kx,ky) x2=1;}else x2=0;	//kierunek osi
  e = dx / 2;   // Wyrażenie błędu
  for(i = 0; i < dx; i++){
    x1 += kx;   // Ruch w kierunku szybkim
    e -= dy;    // Nowe wyrażenie błędu
    if(e < 0){
      y1 += ky; // Ruch w kierunku wolnym
      e += dx;
    }
    // Rysujemy kolejny piksel
    mask >>= 1; if(!mask) mask = 0x80000000;
    if(p&mask){if(x2)plot(y1,x1);else plot(x1,y1);}
  }
EndProc

Procedure ellipse(int xs,int ys,int rx,int ry,SDL_bool f) Def
  if(ry==0 OR rx==0) return;
  if(ry<0) ry=-ry;
  int x,y,e,e1,e2,rx2,ry2,fx,fy,k;
  Uint32 mask=0,p=defline[lin_r];
  // Inicjujemy punkt startowy
  x = e = 0;
  y = ry;
  rx2 = rx * rx;
  ry2 = ry * ry;
  fx = 0;
  fy = rx2 * ry;
  rx=k=1;ry=0;	//gorna cwiartka
  while(y >= 0){
   If(f)	//wypelnienie
     Draw(x + xs,y + ys,-x + xs,y + ys)
     Draw(x + xs,-y + ys,-x + xs,-y + ys)
   Else
    mask >>= 1; if(!mask) mask = 0x80000000;
    if(p & mask){
      plot(x + xs,y + ys);plot(-x + xs,y + ys);
      plot(x + xs,-y + ys);plot(-x + xs,-y + ys);
	}
   EndIf
    if(rx AND fx>fy){rx=0;ry=k=-1; Swap(fx,fy) Swap(ry2,rx2)}	//zmiana cwiartki
    // Wyliczamy wyrażenia błędów
    e1 = e  + k*(fx << 1) + ry2;
    e2 = e1 - k*(fy << 1) + rx2;
    fx += k*ry2;
    x+=rx;y+=ry;
    if(k*(e1 + e2) < 0) e = e1; // Punkt P1
    else{
      y-=rx;x-=ry;
      fy -= k*rx2;
      e = e2;             // Punkt P2
    }
  }
EndProc

Procedure fill(int x,int y,int wyp) Def
  Uint32 ekr[WINDOWW*WINDOWH],map[WINDOWW*WINDOWH],k;
  Uint8 ok=1;
  int dx=1,dy=1,s,l;	//kierunki skanowania
  int py=y,px=x,px0=x,w=WINDOWW,gp=x;
  GetBitmap(0,0,WINDOWW,WINDOWH,ekr) GetBitmap(0,0,WINDOWW,WINDOWH,map)
  k=ekr[x+y*w];	//kolor zapelniany
  For(s,0,1)	//w dol/gore
    While(ok AND y>=0 AND y<WINDOWH)
	 For(l,0,1)	//w prawo/lewo
	  While(map[x+y*w]==k AND x<WINDOWW AND x>=0)
	    if(dx>0)gp=x;
        map[x+y*w]=GEMColor[kolor].BAS;
        srand((x%8+y%8*8)*wyp*1000);
        if(!wyp OR rand()%3) ekr[x+y*w]=GEMColor[kolor].BAS;
        else ekr[x+y*w]=GEMColor[0].BAS;
        x+=dx;
      Wend
      dx=-dx;
      if(!l)x=px+dx;
     Next
	 ok=0;y+=dy;
	 for(x+=dx;x<=gp;x++)if(map[x+y*w]==k){ok=1;break;}	//szukanie k,
	 if(ok)px=x;
	Wend
    x=px=px0;y=py-1;dy=-dy;ok=map[x+y*w]==k;gp=x;
  Next
  ImgBitmap(GEMScreen,ekr,w)
  Target(GEMScreen)
EndProc

Procedure pbox(int x,int y,int x1,int y1) Def
  GEMColor(0)
  PBox(x,y,x1,y1)
  GEMColor(kolor)
  Box(x,y,x1,y1)
  fill(x+(x1-x)/2,y+(y1-y)/2,wyp);
EndProc

Procedure menu() Def	// Rysowanie menu
  int h;
  Target(GEMScreen)
  Color(CFACE)
  Cls
  GEMBoxesDraw(boxy,81)
  GEMColor(kolor)
  PutImg(Wypboxy,426,0)	//Desenie
  pbox(426,224,636,260);	//Aktualny desen
  For(h,1,6)	//Rodzaje linii
    line(420+h*26,268,420+h*26,312,h);
  Next
  line(620,268,620,312,lin_r);	//Aktualny rodzaj linii
  For(h,0,5)	//Grubosc narzedzi
    PCircle(446+h*26,335,h+1)
  Next
  PCircle(620,335,lin_szer/2)	//Aktualna grubosc
EndProc

Procedure krata() Def	//Rysowanie kratki
  Target(kra$)
  Color(0)
  Cls
  If(kr)
    int f;
    ColorRGBA(0,0,0,128)
    for(f=0;f<WINDOWW;f+=krh)Draw(f,0,f,WINDOWH-1)
    for(f=0;f<WINDOWH;f+=krv)Draw(0,f,WINDOWW,f)
  EndIf
  ShowE();
  GEMColor(kolor)
EndProc

Procedure zapamietaj() Def	//Zapamietaj obrazek
  Target(rob_e$)
  InsertImg(GEMScreen)
  Target(GEMScreen)
EndProc

Procedure do_ekranu() Def
  kr=-kr;	//+ rysuj kratke
  Target(GEMScreen)
  InsertImg(rob_e$)	//Wstaw rysunek
  GEMColor(kolor)
  SetDrawBlendMode(tryb_b[tryb])
  ShowE();
EndProc

Procedure do_menu() Def
  zapamietaj();	//Zapamietaj wyglad rysunku
  SetDrawBlendMode(0)
  kr=-kr;
EndProc

Procedure LoadPIC(char*nazwa$,int t) Def
  int dl,wid,hig,n,res,p,x,y;
  Uint8 b[8],k,k1,vk[16]={0,2,3,6,4,7,5,8,9,10,11,14,12,15,13,1};	//kolory VDI
  SDL_Texture*T;
  RWOpen(nazwa$,rb)	//Otworz do odczytu
	If(SDLRWops)	//plik istnieje
      dl=RWLof;	//Wyznacz dlugosc
      If(t>0)	//DEGAS lub 32000 (Doodle)
        If(dl==32066)	//DEGAS
          RWSeek(34,SET)	//omin naglowek
          dl=32000;
        EndIf
        wid=(320+320*(t<4))/8;hig=200+200*(t==1);res=t;
      Else	//Blok
        If(dl>6 AND dl<32007)	//Minimalne i maksymalne rozmiary
          wid=((RWInp*256+RWInp)+15)/16*2;hig=(RWInp*256+RWInp)+1;res=(RWInp*256+RWInp);
          dl-=6;
        EndIf
      EndIf
      If(dl AND dl==wid*hig*res)
        if(res==2)vk[3]=1;
        if(res==1)vk[1]=1;
        CreateImg(T,wid*8,hig)
        Target(T)
        for(y=0;y<hig;y++)
		for(x=0;x<wid*8;x+=16){
          for(n=0;n<2*res;n++)b[n]=RWInp;
          for(p=0;p<8;p++){
          	k=0;k1=0;
		    for(dl=0;dl<res;dl++){if(Btst(b[dl*2],p)) Bset(k,dl) if(Btst(b[dl*2+1],p)) Bset(k1,dl)}
			GEMColor(vk[k]) Plot(x+(7-p),y)
			GEMColor(vk[k1]) Plot(x+(15-p),y)
          Next
        Next
        If(t)
          Target(rob_e$)
          InsertImg(T)
          DeleteImg(T)
        Else
          if(blok$)DeleteImg(blok$)
          blok$=T;
        EndIf
      Else
        GEMAlert(64,100,"Niewłaściwy\nformat pliku",0,"i|Powrót",n)
      EndIf
    Else
      GEMAlert(0,100,"Nie ma takiego pliku",0,"i|Powrót",n)
    EndIf
  RWClose
EndProc

Procedure LoadBMP(char*nazwa$,int t) Def
  SDL_Texture*T=0;
  LoadImg(T,nazwa$)
  If(T)
    If(t==1)
      Target(rob_e$)
      InsertImg(T)
      DeleteImg(T)
    Else
      if(blok$)DeleteImg(blok$)
      blok$=T;
    EndIf
  Else
    GEMAlert(0,50,SDL_GetError(),0,"i|Powrót",n)
  EndIf
EndProc

Procedure laduj(int t) Def	//Ladowanie obrazka z dysku
  STRING nazwa$="";
  char*p;
  GEMFileSelect("Ładowanie","",typ$[t],nazwa$)
  If(Len(nazwa$)>0)	//Pusta nazwa - "Cancel" - powrot
    If((p=strrchr(nazwa$,'.')))
      p++;
      if(strcmp(p,"PIC")==0)LoadPIC(nazwa$,1);
      else if(strcmp(p,"PI1")==0)LoadPIC(nazwa$,4);
      else if(strcmp(p,"PI2")==0)LoadPIC(nazwa$,2);
      else if(strcmp(p,"PI3")==0)LoadPIC(nazwa$,1);
      else if(strcmp(p,"bmp")==0 OR strcmp(p,"BMP")==0)LoadBMP(nazwa$,t);
      else if(strcmp(p,"GBF")==0)LoadPIC(nazwa$,0);
      else p=0;
    EndIf
    if(!p)GEMAlert(16,100,"Nieznany typ pliku",0,"i|Powrót",n)
  EndIf
EndProc

Procedure zapisz(int t) Def	//Zapisanie obrazka na dysk
  int n=0;
  STRING nazwa$="";Add(nazwa$,typ$[t])
  if(t==0)Add(nazwa$,"C")
  Uint8 buf[640*400*4];
/*  // ***  Standardowe naglowki i t.p. DEGAS'a ***
Uint8 pi1_hdr[]={	//Dla niskiej rozdzielczosci
  0x00,0x00,0x07,0x77,0x07,0x00,0x00,0x70,0x07,0x70,
  0x00,0x07,0x07,0x07,0x00,0x77,0x05,0x55,0x03,0x33,
  0x07,0x33,0x03,0x73,0x07,0x73,0x03,0x37,0x07,0x37,
  0x03,0x77,0x00,0x00};
Uint8 pi1_tail[]={
  0x00,0x00,0x00,0x04,0x00,0x08,0x00,0x0C,0x00,0x03,
  0x00,0x07,0x00,0x0B,0x00,0x0F,0x00,0x01,0x00,0x01,
  0x00,0x01,0x00,0x01,0x00,0x80,0x00,0x54,0x00,0x2A,
  0x00,0x00};
Uint8 pi2_hdr[]={	//Dla sredniej rozdzielczosci
  0x00,0x01,0x07,0x77,0x07,0x00,0x00,0x70,0x00,0x00,
  0x00,0x07,0x07,0x07,0x00,0x77,0x05,0x55,0x03,0x33,
  0x07,0x33,0x03,0x73,0x07,0x73,0x03,0x37,0x07,0x37,
  0x03,0x77,0x00,0x00};
Uint8 pi2_tail[]={
  0x00,0x00,0x00,0x01,0x00,0x02,0x00,0x03,0x00,0x00,
  0x00,0x01,0x00,0x02,0x00,0x03,0x00,0x01,0x00,0x01,
  0x00,0x01,0x00,0x01,0x00,0x80,0x00,0x54,0x00,0x2A,
  0x00,0x00};
Uint8 pi3_hdr[]={	//DLA WYSOKIEJ ROZDZIELCZOSCI
  0x00,0x02,0x07,0x77,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00};
Uint8 pi3_tail[]={
  0x00,0x00,0x00,0x01,0x00,0x02,0x00,0x03,0x00,0x00,
  0x00,0x01,0x00,0x02,0x00,0x03,0x00,0x01,0x00,0x01,
  0x00,0x01,0x00,0x01,0x00,0x80,0x00,0x54,0x00,0x2A,
  0x00,0x00};
*/
  GEMFileSelect("Zapis","",typ$[t],nazwa$)
  If (Len(nazwa$)>0)	//Pusta nazwa - "Cancel" - powrot
    Target(rob_e$)
      If(t==0)	//Doodle
        RWOpen(nazwa$,wb)	//Otworz plik do zapisu
	    If(SDLRWops)
          GetBitmap(0,0,640,400,buf)
          Uint32*p=(Uint32*)buf,*ps=p,m=0xFFFFFF;
          Uint8 b;
          While(p<ps+640*400)
            if(BStst(*p,m))Bclr(b,7-n) else Bset(b,7-n)
            p++;n=(n+1) MOD 8;
            if(n==0)RWOut(b)
          Wend
          RWClose	//Zamknij plik
        Else
          GEMAlert(8,100,"Błąd otwarcia pliku",0,"i|Powrót",n)
        EndIf
      ElseIf(t==1)	//bmp
        SaveBMP(0,0,640,400,nazwa$)
      Else//Blok - zapisz go
        Target(blok$)
		ImgSize(blok$)
        SaveBMP(0,0,SRC.w,SRC.h,nazwa$)
      EndIf
  EndIf
EndProc

Procedure cz_mysz() Def
  SDL_Event e;
  k=0;key=0;
  while(!Quit && SDL_WaitEvent(&e)){
		switch(e.type){
		case SDL_KEYDOWN:key=e.key.keysym.sym;Quit=1;break;
		case SDL_MOUSEBUTTONDOWN:
		case SDL_MOUSEMOTION:x=e.button.x;y=e.button.y;k=e.button.button;Quit=1;
		}}
  Quit=0;
EndProc

//*** Pomocnicze procedury do wyznaczania ksztaltu rysowanego obiektu ***

Procedure wsp(SDL_Rect*w) Def	//Ustalenie wspolrzednych rysowanego obiektu
  Uint8 l=lin_r,ls=lin_szer;lin_szer=1;lin_r=0;
  w->x=x;	//Wspolrzedne poczatkowe
  w->y=y;
  Target(0)
  WaitMouseU
  Repeat
    w->w=x;	//Aktualne wspolrzedne
    w->h=y;
    InsertImg(GEMScreen)
    if(kr>0)InsertImg(kra$)
    Select(co/2)	//Aktualny ksztalt
	  Case 1:Draw(w->x,w->y,w->w,w->h)
	  Case 2:Box(w->x,w->y,w->w,w->h)
	  Case 3:Circle(w->x,w->y,SDL_sqrt((w->x-w->w)*(w->x-w->w)+(w->y-w->h)*(w->y-w->h)))
	  Case 4:ellipse(w->x,w->y,w->w-w->x,w->h-w->y,0);
	EndSelect
    ShowPage
    cz_mysz();
  Until(k!=0)
  Target(GEMScreen)
  WaitMouseU
  lin_r=l;lin_szer=ls;
EndProc

//	***** Procedury rysunkowe *****

Procedure rysuj() Def	//Rysunek z wolnej reki
  int ox=x,oy=y;	//Stare wspolrzedne
  Do
    if(k!=1)Break	//Rysowanie gdy nacisniety lewy k. m.
    line(ox,oy,x,y,lin_r);
    ox=x;
    oy=y;
    ShowE();
    cz_mysz();
  Loop
EndProc

Procedure linia() Def	//Rysowanie odcinka
  SDL_Rect w={0};
  wsp(&w);
  If(k==1)
    line(w.x,w.y,w.w,w.h,lin_r);
  EndIf
EndProc

Procedure lamana() Def
  SDL_Rect w={0};
  Repeat
    wsp(&w);
    If(k==1)
      line(w.x,w.y,w.w,w.h,lin_r);
    EndIf
    WaitMouseU
    x=w.w;
    y=w.h;
  Until (k>1)	//Powtarzaj do nacisniecia prawego k. m.
  k=0;
EndProc

Procedure ramka() Def
  SDL_Rect w={0};
  wsp(&w);
  If(k==1)
    line(w.x,w.y,w.w,w.y,lin_r);
    line(w.x,w.h,w.w,w.h,lin_r);
    line(w.x,w.y,w.x,w.h,lin_r);
    line(w.w,w.y,w.w,w.h,lin_r);
  EndIf
EndProc

Procedure prostok() Def
  SDL_Rect w={0};
  wsp(&w);
  If(k==1)
    pbox(w.x,w.y,w.w,w.h);
  EndIf
EndProc

Procedure okrag() Def
  SDL_Rect w={0};
  wsp(&w);
  If(k==1)
    int r=SDL_sqrt((w.x-w.w)*(w.x-w.w)+(w.y-w.h)*(w.y-w.h));
    ellipse(w.x,w.y,r,r,0);
  EndIf
EndProc

Procedure kolo() Def
  SDL_Rect w={0};
  Uint8 l=lin_r,ls=lin_szer;lin_szer=1;lin_r=0;
  wsp(&w);
  If(k==1)
    int r=SDL_sqrt((w.x-w.w)*(w.x-w.w)+(w.y-w.h)*(w.y-w.h));
    GEMColor(0)
    ellipse(w.x,w.y,r,r,1);
    GEMColor(kolor)
    ellipse(w.x,w.y,r,r,0);
    fill(w.x,w.y,wyp);
  EndIf
  lin_r=l;lin_szer=ls;
EndProc

Procedure elipsa() Def
  SDL_Rect w={0};
  wsp(&w);
  If(k==1)
    ellipse(w.x,w.y,w.w-w.x,w.h-w.y,0);
  EndIf
EndProc

Procedure dysk() Def
  SDL_Rect w={0};
  Uint8 l=lin_r,ls=lin_szer;lin_szer=1;lin_r=0;
  wsp(&w);
  If(k==1)
    GEMColor(0)
    ellipse(w.x,w.y,w.w-w.x,w.h-w.y,1);
    GEMColor(kolor)
    ellipse(w.x,w.y,w.w-w.x,w.h-w.y,0);
    fill(w.x,w.y,wyp);
  EndIf
  lin_r=l;lin_szer=ls;
EndProc

Procedure t_undo() Def	//Jezeli nacisniety "UNDO"
  If(key==SDLK_BACKSPACE)
    Target(GEMScreen)
    InsertImg(rob_e$)	//wczesniejszy obraz
    ShowE();
  EndIf
EndProc

Procedure t_nawias() Def	//zmiana kratki
  If(key==44 OR key==46)	//<>
    kr=kr+(key==46 AND kr<10)-(key==44 AND kr>0);
    krh=kr*8;
    krv=kr*8;
    krata();
  EndIf
EndProc

Procedure rog(SDL_Rect*o) Def	//Ustalenie wspolrzednych wierzcholka bloku
  ShowM(0)
  Target(0)
  Repeat
    InsertImg(GEMScreen)
	if(kr>0)InsertImg(kra$)
    o->x=x;
    o->y=y;
    Draw(0,o->y,WINDOWW,o->y)	//Rysuj krzyz
    Draw(o->x,0,o->x,WINDOWH)
    Draw(0,o->h,WINDOWW,o->h)	//Pierwszy krzyz
    Draw(o->w,0,o->w,WINDOWH)
    ShowPage
    cz_mysz();
  Until(k!=0 OR key==27)
EndProc

Procedure wytnij() Def	//Wycinanie bloku
  SDL_Rect o={0,0,-1,-1};
  rog(&o);	//Wyznaczenie wspolrzednych 1-ego rogu
  If(k==1 AND key!=27)	//Jezeli lewy k. m. i nie nacisniete ESC
    o.w=o.x;
    o.h=o.y;
    rog(&o);	//Drugi rog
    If(k==1 AND key!=27)
      if(blok$)DeleteImg(blok$)
      CreateImg(blok$,o.x-o.w+1,o.y-o.h+1)
	  Target(blok$)
	  SRC(o.w,o.h,o.x-o.w+1,o.y-o.h+1)
      SDL_RenderCopy(SDLRenderer,GEMScreen,&SRC,0);	//Zapamietaj blok
    EndIf
  EndIf
EndProc

Procedure blok() Def	//Wycinanie i wklejanie bloku
  Repeat
    Target(0)
    InsertImg(GEMScreen)
    If(blok$)	//Jezeli jest blok
      ImgBlendMode(blok$,tryb_b[tryb])
	  PutImg(blok$,x,y)	//Wklej blok
      If(k==1)	//Jezeli nacisniety lewy klawisz myszy
        zapamietaj();
        PutImg(blok$,x,y)
        Target(0)
        InsertImg(GEMScreen)
      EndIf
    Else
      ShowM(1)
    EndIf
	if(kr>0)InsertImg(kra$)
    ShowPage
    cz_mysz();	//Czytaj mysz i klawiature
	If(key==27)	//ESC uaktywnia wycinanie
      wytnij();
      k=0;
    EndIf
    t_undo();	//UNDO ?
    t_nawias();	//[] ?
  Until(k>1)	//Powrot po nacisnieciu prawego k. m.
  ShowM(1)
EndProc

Procedure porys(int px,int py,int sk) Def	//Rysowanie w powiekszeniu
  int gx=sk*krh+220,gy=sk*krv;
  Do
    GEMShow
    Target(GEMScreen)
    cz_mysz();
    If(k==1 AND x<192 AND y<12)
      GEMColor(x/12)
    EndIf
    If(k==1 AND x>220 AND x<gx AND y<gy)
      x=(x-220)/sk;
      y=y/sk;
      Plot(px+x,py+y)
      PRect(220+x*sk,y*sk,sk,sk)
    EndIf
  Until(k>1)
EndProc

Procedure powieksz() Def	//Powiekszenie danej kratki
  int korx=0,kory=0,px,py,pkx,pky,px0,py0,px1,py1,sk,c;
  SDL_Texture*pow$=0;
  If(kr)
    px=x/krh*krh;	//Wspolrzedne kratki
    py=y/krv*krv;
    pkx=px;
    pky=py;
    px0=px-100+krh/2;	//Wspolrzedne podgladu
    If(px0<0)
      korx=-px0;	//Korekta wsporzednych
      px0=0;
    EndIf
    px1=px+100-1+krh/2;
    If(px1>WINDOWW-1)
      px1=WINDOWW-1;
    EndIf
    py0=py-100+krv/2;
    If(py0<0)
      kory=-py0;	//Korekta
      py0=0;
    EndIf
    py1=py+100-1+krv/2;
    If(py1>WINDOWH-1)
      py1=WINDOWH-1;
    EndIf
    CreateImg(pow$,px1-px0+1,py1-py0+1)
    Target(pow$)
    SRC(px0,py0,px1-px0+1,py1-py0+1)	//Wyciecie danego obszaru
    SDL_RenderCopy(SDLRenderer,GEMScreen,&SRC,0);
    Target(GEMScreen)
	GEMColor(0) Cls GEMColor(1)
    PutImg(pow$,korx,100+kory)	//i wklejenie go (podglad)
    px=100-krh/2;	//Wspolrzedne kratki
    py=200-krv/2;
    sk=WINDOWH/krv;	//Skala powiekszenia
    Rect(px-1,py-1,krh+2,krv+2)	//ramka
    PBox(200,0,219,WINDOWH-1)
    PBox(620,0,WINDOWW-1,WINDOWH-1)
    For(c,0,15)	//Kolory
      GEMColor(c)
      PRect(c*12,0,12,12)
    Next
    SRC(pkx,pky,WINDOWH/sk,WINDOWH/sk) DST(220,0,WINDOWH/sk*sk,WINDOWH/sk*sk)
    PutImgRect(rob_e$,SRC,DST)
    GEMColor(kolor)
    porys(px,py,sk);	//Rysowanie w powiekszeniu
    DeleteImg(pow$)
    CreateImg(pow$,krh,krv)
    Target(pow$)
	SRC(px,py,krh,krv)
	SDL_RenderCopy(SDLRenderer,GEMScreen,&SRC,0);
    Target(GEMScreen)
    InsertImg(rob_e$)
    PutImg(pow$,pkx,pky)
  EndIf
  if(pow$)DeleteImg(pow$)
  WaitMouseU
  k=0;
EndProc

Procedure pracownia() Def	//Rysowanie, malowanie...
  Do
    Repeat	//Czytaj mysz i klawiature
      cz_mysz();
      t_undo();	//UNDO ?
      t_nawias();	//<> ?
    Until(k!=0 OR co==10)	//(wyjatek dla Bloku)
    zapamietaj();	//Zapamietaj obrazek (dla UNDO)
    if(k>1)return;	//Prawy k. m. - przejscie do menu
    Select(co)	//Rysuj i t.p.
      Case 0:plot(x,y);
      Case 1:rysuj();
      Case 2:linia();
      Case 3:lamana();
      Case 4:ramka();
      Case 5:prostok();
      Case 6:okrag();
      Case 7:kolo();
      Case 8:elipsa();
      Case 9:dysk();
      Case 10:blok();
      Case 11:fill(x,y,wyp);
      Case 12:powieksz();
    EndSelect
    ShowE();
  Until(k>1)	//Powtarzaj
  WaitMouseU
EndProc

Procedure sterownia() Def	//Glowna czesc programu
  int pyt,sel;
  Do
    menu();
    ShowE();
    WaitMouseU
    GEMMenu(boxy,81,0,sel)
    k=MouseK;x=MouseX;y=MouseY;
    If(k==1)	//Lewy klawisz myszy - wybor opcji
      If(sel>=8 AND sel<=20)	//Wybor narzedzia
        co=sel-8;
      EndIf
      If(sel>=2 AND sel<=7)	//Operacje dyskowe
        If(sel MOD 2)
          zapisz((sel-3)/2);
        Else
          laduj((sel-2)/2);
        EndIf
      EndIf
      If(sel>=24 AND sel<=59)	//Wybor deseniu
        wyp=sel-24;
      EndIf
      If(sel==63)	//Wybor grubosci narzedzia
        lin_szer=((x-406)/26)*2;
      EndIf
      If(sel==64)	//kropka
        lin_szer=1;
      EndIf
      If(sel==61)	//Wybor rodzaju linii
        lin_r=(x-406)/26;
      EndIf
	  If(sel==62)	//Wybor rodzaju linii
        lin_r=0;
      EndIf
      If(sel==21)	//Wybor trybu graficznego
        tryb=(tryb+1) MOD 5;
        boxy[21].Text=tryb$[tryb];
      EndIf
      If(sel>=65 AND sel<=80)	//Wybor koloru
        kolor=sel-65;
      EndIf
      Colors(-1,255)
      If(sel==22)	//"Czysc"
        GEMAlert(24,100,"Wyczyścić ekran ?",1,"?| Tak | Nie ",pyt)
        If(pyt==0)
          Target(rob_e$)
          GEMColor(0) Cls
        EndIf
      EndIf
      If(sel==23)	//"Koniec"
        GEMAlert(24,100,"Koniec programu ?",1,"?| Tak | Nie ",pyt)
        If(pyt==0)
          return;
        EndIf
      EndIf
    EndIf
    If(k>1)	//Przejscie do ekranu roboczego
      WaitMouseU
      do_ekranu();	//Pokaz rysunek
      pracownia();	//Rysujemy...
      do_menu();	//Pokaz menu
    EndIf
  Loop
EndProc

MAIN
  int h,v;
  SDLOpen(0)
  CreateImg(rob_e$,WINDOWW,WINDOWH)
  CreateImg(GEMScreen,WINDOWW,WINDOWH)
  CreateImg(kra$,WINDOWW,WINDOWH)
  ImgBlendMode(kra$,1)
  CreateImg(Wypboxy,210,216)
  ImgBlendMode(Wypboxy,1)
  Target(rob_e$)
  GEMColor(0)
  Cls
  tryb_b[4]=SDL_BLENDMODE_REV;
  //Tworzenie menu
  For(h,0,1)	//"Laduj", "Zapisz"
    BOX(boxy[h],8+h*204,8,200,24)
    boxy[h].State=2;	//nieaktywne
    boxy[h].Type=1;
  Next
  For(v,0,2)	//Formaty plikow 2-7
    For(h,0,1)
      BOX(boxy[v*2+h+2],8+h*204,32+24*v,200,24)
      boxy[v*2+h+2].State=1+2+8;
      boxy[v*2+h+2].Type=1;
    Next
  Next
  For(v,0,5)	//Narzedzia 8-19
    For(h,0,1)
      BOX(boxy[v*2+h+8],8+h*204,152+28*v,200,24)
      boxy[v*2+h+8].State=3+16;
      boxy[v*2+h+8].Type=1;
    Next
  Next
  BOX(boxy[20],8,116,200,24)	//Powiekszenie
  boxy[20].State=3+16;
  boxy[20].Type=1;
  BOX(boxy[21],212,116,200,24)	//Tryby grafiki
  boxy[21].Text=tryb$[tryb];
  boxy[21].State=3+8;
  boxy[21].Type=1;
  For(h,0,1)	//"Czysc", "Koniec" 22,23
    BOX(boxy[h+22],8+h*204,370,200,24)
    boxy[h+22].State=3+8;
    boxy[h+22].Type=1;
  Next
  Target(GEMScreen)
  Color(0)
  Cls
  Color(-1)
  For(v,0,5)	//Desenie 24-59
    For(h,0,5)
      BOX(boxy[v*6+h+24],426+h*36,v*36+8,30,28)
      boxy[v*6+h+24].State=11;
      boxy[v*6+h+24].Type=0;
      PRect(h*36,v*36+8,30,28)
      fill(15+h*36,v*36+22,wyp);
      wyp++;
    Next
  Next
  wyp=0;
  Target(Wypboxy)
  PutImg(GEMScreen,0,0)
  BOX(boxy[60],426,354,210,40)
  boxy[60].Text="NIKIFOR 2";
  boxy[60].State=2;
  boxy[60].Type=1;
  boxy[60].s=1;boxy[60].n=CTEXTBG;
  BOX(boxy[61],426,264,174,52)	//Rodzaje linii
  BOX(boxy[62],606,264,30,52)	//ciagla
  BOX(boxy[63],426,320,174,30)	//Grubosc
  BOX(boxy[64],606,320,30,30)	//kropka
  For(h,61,64)
    boxy[h].State=11;
    boxy[h].Type=0;
  Next
  For(h,0,15)	//Kolory 65-80
    BOX(boxy[h+65],8+h*25,320,21,22)
    boxy[h+65].State=11;
    boxy[h+65].Type=0;
    boxy[h+65].s=1;boxy[h+65].n=GEMColor[h].BAS;
  Next
  boxy[9].State=7+16;	//aktualna opcja / narzedzie - rysowanie
  sterownia();	// Glowna petla programu
  DeleteImg(rob_e$)
  DeleteImg(kra$)
  DeleteImg(blok$)
  DeleteImg(GEMScreen)
  DeleteImg(Wypboxy)
ENDMAIN
